=== debian/watch ===
version=4
opts="mode=git, pgpmode=none,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/,\
      dversionmangle=s/\+ds\d*$//, repacksuffix=+ds1" \
  https://github.com/kata-containers/kata-containers \
  refs/tags/v?@ANY_VERSION@ debian
